import sys
from cv2 import cv2
import os
import glob
import time
import configparser
print("Num of Parameter:",len(sys.argv))
'''
show or not show result image :   s:0 (now show)   s:1000  (show result image 1 second per picture)
example : 
    Contour_Similarity_inf.exe s:100 P:d:/aaa/
    Contour_Similarity_inf.exe s:100 P:./aaa/
    
'''
show_result_image=0
result_image_path=''
n=len(sys.argv)
for p0 in range(1,n):   # skip first exe name
    
    s=sys.argv[p0]
    colon_index = s.index(':')
    s0=s[:colon_index]
    if s0=="s" or s0=='S':   #show,save image or not 
        i0=int(s[colon_index+1:])
        print ("s parameter found")
        print("t=",i0,"ms")
        show_result_image=i0
    if s0=="P" or s0=='p':   # path
        result_image_path=s[colon_index+1:]
        print ("P parameter found")
        print("Result_image_path: ",result_image_path)
        if not os.path.exists(result_image_path):
            # Create the directory if it does not exist
            os.makedirs(result_image_path)
            print(f"Created directory: {result_image_path}")
        else:
            print(f"Directory already exists: {result_image_path}")
           

# show_result_image = 1  #  0  no show, none >0 :show n mS
# 設定目錄路徑

#dut_path = './DUT/'  # dut 圖片位置
dir_path_0 = os.path.dirname(os.path.dirname(dut_path))
if not os.path.exists(dut_path):
    # Create the directory if it does not exist
    os.makedirs(dut_path)
    print(f"Created directory: {dut_path}")
else:
    print(f"Directory already exists: {dut_path}")

#dir_path_ref = parent_dir = dir_path_0 + "/REF/"  # Golden smaple 圖片位置

# 使用 glob 模塊列出目錄下所有 JPG 檔案
jpg_files = glob.glob(os.path.join(dut_path, '*.[jJ][pP][gG]'))
inf_file_name = dir_path_ref +"Contour_Similarity.inf"

write_config = configparser.ConfigParser()

if os.path.exists(inf_file_name):
    write_config.read(inf_file_name)
else:
    write_config.add_section("Contour_Similarity")

write_config.set("Contour_Similarity", "Running_status", str(1))
cfgfile = open(inf_file_name,'w')
write_config.write(cfgfile)
cfgfile.close()
valid_DUT_files_cnt=0;
valid_REF_files_cnt=0;


# 逐一印出所有 JPG 檔案的檔名
for jpg_file in jpg_files:
    #寫INF
    write_config.set("Contour_Similarity", "%s" % os.path.basename(jpg_file), str(0))
    if os.path.exists(jpg_file):
        print("DUT file: ",jpg_file)
        valid_DUT_files_cnt=valid_DUT_files_cnt+1
    else:
        print("DUT file: ",jpg_file," not exist")
        continue
    jpg_file_0 = os.path.basename(jpg_file)
    jpg_file_0 = dir_path_ref+jpg_file_0

    if os.path.exists(jpg_file_0):
        print("Ref file: ",jpg_file_0)
        valid_REF_files_cnt=valid_REF_files_cnt+1
    else:
        print("Ref file: ",jpg_file_0," not exist")
        continue

    # 读取两张图像
    img1 = cv2.imread(jpg_file)
    img2 = cv2.imread(jpg_file_0)
    # img1 = cv2.resize(img1, (img2.shape[1], img2.shape[0]))

    # 将图像转换为灰度
    img1_gray = cv2.cvtColor(img1, cv2.COLOR_BGR2GRAY)
    img2_gray = cv2.cvtColor(img2, cv2.COLOR_BGR2GRAY)

    # 使用Canny算子提取图像轮廓
    edges1 = cv2.Canny(img1_gray, 100, 255)
    edges2 = cv2.Canny(img2_gray, 100, 255)

    # 提取轮廓
    contours1, hierarchy1 = cv2.findContours(
        edges1, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)
    contours2, hierarchy2 = cv2.findContours(
        edges2, cv2.RETR_EXTERNAL, cv2.CHAIN_APPROX_SIMPLE)

    # 绘制轮廓
    cv2.drawContours(img1, contours1, -1, (0, 0, 255), 1)
    cv2.drawContours(img2, contours2, -1, (0, 0, 255), 1)

    # 计算轮廓相似度

    # 比较两个图像的轮廓
    result = cv2.matchShapes(edges1, edges2, cv2.CONTOURS_MATCH_I1, 0)

    result = 1- result;
    if result<0:
        result= 0

    # 判断是否完全相同，相同则显示100%
   
    print("Contour_Similarity: ",result )
    
    if show_result_image>0:
      # 显示图像
      #擴展
      img1 = cv2.resize(img1, (img2.shape[1], img2.shape[0]))  # 以img2 的size 當參考 縮放
      # 水平合并
      merged = cv2.hconcat([img1, img2])
      merged = cv2.copyMakeBorder(merged,000,40,0,0,cv2.BORDER_CONSTANT, value=[0, 0, 0])
      # 显示合并后的图像
      #字    
      text = 'Similarity: {:8.8f}'.format(result)
      color = (255, 255, 0)  # 文本颜色  B G R
      thickness = 2  # 文本线宽
      org = (10, merged.shape[0]-10)
      font = cv2.FONT_HERSHEY_SIMPLEX  # 字体类型
      font_scale = 1  # 字体大小
      #匯入字
      merged = cv2.putText(merged, text, org, font, font_scale, color, thickness)

      #檔案名稱
      local_time = time.localtime()
      # 将时间格式化为HH:MM:SS的字符串格式
      time_string = time.strftime('%H:%M:%S', local_time)
      # 分别提取小时、分钟和秒数
      hour, minute, second = time_string.split(':')
      image_file_name =result_image_path+ "result_" + os.path.basename(jpg_file)
      # cv2.imwrite("output.jpg", merged)
      print ("save file name: ", image_file_name)
      cv2.imwrite(image_file_name, merged)

      #顯示影像
      cv2.imshow('Contour_Similarity ', merged)
      cv2.waitKey(show_result_image)
      # time.sleep(2);
      cv2.destroyAllWindows()
    
    #寫INF
    write_config.set("Contour_Similarity", "%s" % os.path.basename(jpg_file), str(result))

write_config.set("Contour_Similarity", "Running_status", str(0))
write_config.set("Contour_Similarity", "valid_DUT_files_cnt", str(valid_DUT_files_cnt))
write_config.set("Contour_Similarity", "valid_REF_files_cnt", str(valid_REF_files_cnt))
cfgfile = open(inf_file_name,'w')
write_config.write(cfgfile)
cfgfile.close()
